import { InfernoChildren, InfernoInput } from '../core/VNodes';
export declare const componentToDOMNodeMap: Map<any, any>;
/**
 * When inferno.options.findDOMNOdeEnabled is true, this function will return DOM Node by component instance
 * @param ref Component instance
 * @returns {*|null} returns dom node
 */
export declare function findDOMNode(ref: any): any;
/**
 * Renders virtual node tree into parent node.
 * @param {VNode | null | string | number} input vNode to be rendered
 * @param parentDom DOM node which content will be replaced by virtual node
 * @returns {InfernoChildren} rendered virtual node
 */
export declare function render(input: InfernoInput, parentDom: Element | SVGAElement | DocumentFragment | null | HTMLElement | Node): InfernoChildren;
export declare function createRenderer(parentDom?: any): (lastInput: any, nextInput: any) => void;
